//
//  SendOrderViewController.m
//  DemoNganLuong
//
//  Created by Hung Le Dinh on 6/22/16.
//  Copyright © 2016 Hung Le Dinh. All rights reserved.
//

#import "SendOrderViewController.h"
#import "WebNganLuongController.h"

@interface SendOrderViewController ()<UITextFieldDelegate>
@property (weak, nonatomic) IBOutlet UITextField *mtfName;
@property (weak, nonatomic) IBOutlet UITextField *mtfTotalMoney;
@property (weak, nonatomic) IBOutlet UITextField *mtfEmail;
@property (weak, nonatomic) IBOutlet UITextField *mtfPhone;
@property (weak, nonatomic) IBOutlet UITextField *mtfAddress;

@property (nonatomic , strong) NSMutableDictionary * dict;

@end

@implementation SendOrderViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    _dict = [[NSMutableDictionary alloc]init];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
- (IBAction)actionOrder:(UIButton *)sender {
    BOOL isSuccess = [self funCheckInfo];
    if (isSuccess) {
        NSMutableDictionary * dicParam = [self sendOrder_merchent_id:MERCHANT_ID merchent_password:MERCHANT_PASSWORD merchent_email:MERCHANT_ACCOUNT order_code:ORDER_CODE];
        [self postData:dicParam];
    }
}

#pragma mark - Update data

-(NSMutableDictionary*)sendOrder_merchent_id:(NSString*) merchent_id merchent_password:(NSString*) merchent_password merchent_email:(NSString*) merchent_email order_code:(NSString*)order_code{
    /*
     
     - Thông tin merchent_id , merchent_password , merchent_email đang được fix cứng là tài khoản Dev tương ứng dùng MAIN_URL_DEV để kết nối server
     - Nếu muốn dùng MAIN_URL_PUBLIC thì phải dùng merchent thật đăng kí tại Ngân lượng để kết nối
     - Hiện tại đang để link MAIN_URL_PUBLIC và các merchent vẫn để của dev , đăng kí merchent trên Ngân lượng để lấy merchent và thay vào merchent đang fix cứng
     
     */
    
    NSArray* arrayKey = [[NSArray alloc] initWithObjects:@"func",@"version",@"merchant_id",@"merchant_account",@"order_code",@"total_amount",@"currency",@"language",@"return_url",@"cancel_url",@"notify_url",@"buyer_fullname",@"buyer_email",@"buyer_mobile",@"buyer_address", nil];
    NSArray* arrayValue = [[NSArray alloc] initWithObjects:FUNC_ORDER,VERSION,merchent_id,merchent_email,order_code,_mtfTotalMoney.text,CURRENCY,LANGUAGE,RETURN_URL,CANCEL_URL,NOTIFY_URL,_mtfName.text,_mtfEmail.text,_mtfPhone.text,_mtfAddress.text, nil];
    NSMutableDictionary* parameters = [[NSMutableDictionary alloc] initWithObjects:arrayValue forKeys:arrayKey];
    NSString * checksum;
    NSString* value = [NSString stringWithFormat:@"%@|%@",[arrayValue componentsJoinedByString:@"|"],merchent_password];
    checksum = [value MD5];
    NSDictionary* dchecksum = [[NSDictionary alloc] initWithObjectsAndKeys:checksum,@"checksum", nil];
    [parameters addEntriesFromDictionary:dchecksum];
    return parameters;
}

#pragma mark - Connect server
- (void)postData:(NSDictionary*)dict
{
    [self showToastActivity];
    [ManagerAPI postDataFromServer:MAIN_URL_PUBLIC andInfo:dict completionHandler:^(NSDictionary *resultDict) {
        [self parserData:resultDict];
    } errorHandler:^(NSError *error) {
        [self errorMessage:error];
    }];
}

- (void)parserData:(NSDictionary*)dict
{
    if ([[dict objectForKey:@"response_code"] intValue] == 0) {
        UIStoryboard * storyBoard = [UIStoryboard storyboardWithName:@"Main" bundle:nil];
        WebNganLuongController * web = [storyBoard instantiateViewControllerWithIdentifier:@"WebNganLuongController"];
        web.gstrUrl = [dict objectForKey:@"checkout_url"];
        web.token_code = [dict objectForKey:@"token_code"];
        [self.navigationController pushViewController:web animated:YES];
    }
    else{
        NSString * message = [[ToolFunctions shareToolFunction]parserError:[[dict objectForKey:@"response_code"] intValue]];
        UIAlertView * alert = [[UIAlertView alloc]initWithTitle:@"Lỗi" message:message delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
        [alert show];
    }
    
    [self hidenToastActivity];
}

- (void)errorMessage:(NSError*)error
{
    [self hidenToastActivity];
    UIAlertView * alert = [[UIAlertView alloc]initWithTitle:@"Lỗi" message:[NSString stringWithFormat:@"%@",error.localizedDescription] delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
    [alert show];
}



- (BOOL)funCheckInfo
{
    if ([_mtfName.text isEqualToString:@""]) {
        [self showMessage:@"Nhập Họ và tên người thanh toán "];
        return NO;
    }
    else if ([_mtfName.text length] > 250){
        [self showMessage:@"Họ và tên dài quá 250 kí tự"];
        return NO;
    }
    if ([_mtfTotalMoney.text isEqualToString:@""]) {
        [self showMessage:@"Nhập Tổng số tiền đơn hàng thanh toán "];
        return NO;
    }
    else if ([_mtfTotalMoney.text intValue] < 2000){
        [self showMessage:@"Tổng tiền đơn hàng không thể nhỏ hơn 2000 VNĐ"];
        return NO;
    }
    if ([_mtfEmail.text isEqualToString:@""]) {
        [self showMessage:@"Nhập Email người thanh toán "];
        return NO;
    }
    else if (![[ToolFunctions shareToolFunction]validateEmail:_mtfEmail.text]){
        [self showMessage:@"Email không đúng"];
        return NO;
    }
    if ([_mtfPhone.text isEqualToString:@""]) {
        [self showMessage:@"Nhập Số điện thoại người thanh toán "];
        return NO;
    }
    else if (![[ToolFunctions shareToolFunction]validateNumber:_mtfPhone.text]){
        [self showMessage:@"Số điện thoại không đúng"];
        return NO;
    }
    if ([_mtfAddress.text isEqualToString:@""]) {
        [self showMessage:@"Nhập Địa chỉ người thanh toán "];
        return NO;
    }
    return YES;
}

#pragma mark - Toast View

- (void)showMessage:(NSString*)messgae
{
    [self.view makeToast:messgae duration:3.0 position:CSToastPositionCenter];
}

- (void)showToastActivity
{    CSToastStyle *style = [[CSToastStyle alloc] initWithDefaultStyle];
    style.backgroundColor = [UIColor clearColor];
    [CSToastManager setSharedStyle:style];
    [self.view makeToastActivity:CSToastPositionCenter];
}

- (void)hidenToastActivity
{
    [self.view hideToastActivity];
}
@end
