//
//  SuccessController.m
//  DemoNganLuong
//
//  Created by Hung Le Dinh on 6/23/16.
//  Copyright © 2016 Hung Le Dinh. All rights reserved.
//

#import "SuccessController.h"

@interface SuccessController ()

@property (weak, nonatomic) IBOutlet UITextView *mtvContent;
@end

@implementation SuccessController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
 
    NSMutableDictionary* querystring = [self sendCheckOut_merchent_id:MERCHANT_ID merchent_password:MERCHANT_PASSWORD];
    [self showToastActivity];
    [self postData:querystring];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Update data

-(NSMutableDictionary*)sendCheckOut_merchent_id:(NSString*) merchent_id merchent_password:(NSString*) merchent_password{
    
    /*
     
     - Thông tin merchent_id , merchent_password , merchent_email đang được fix cứng là tài khoản Dev tương ứng dùng MAIN_URL_DEV để kết nối server
     - Nếu muốn dùng MAIN_URL_PUBLIC thì phải dùng merchent thật đăng kí tại Ngân lượng để kết nối
     - Hiện tại đang để link MAIN_URL_PUBLIC và các merchent vẫn để của dev , đăng kí merchent trên Ngân lượng để lấy merchent và thay vào merchent đang fix cứng
     
     */
    
    
    NSArray* arrayKey = [[NSArray alloc] initWithObjects:@"func",@"version",@"merchant_id",@"token_code", nil];
    NSArray* arrayValue = [[NSArray alloc] initWithObjects:FUNC_CHECK_OUT,VERSION,merchent_id,self.token_code, nil];
    NSMutableDictionary* parameters = [[NSMutableDictionary alloc] initWithObjects:arrayValue forKeys:arrayKey];
    NSString * checksum;
    NSString* value = [NSString stringWithFormat:@"%@|%@",[arrayValue componentsJoinedByString:@"|"],merchent_password];
    checksum = [value MD5];
    NSDictionary* dchecksum = [[NSDictionary alloc] initWithObjectsAndKeys: checksum,@"checksum", nil];
    [parameters addEntriesFromDictionary:dchecksum];
    return parameters;
}


- (IBAction)actionBack:(UIButton *)sender {
    [self.navigationController popToRootViewControllerAnimated:YES];
}

#pragma mark - Connect server
- (void)postData:(NSDictionary*)dict
{
    [self showToastActivity];
    [ManagerAPI postDataFromServer:MAIN_URL_PUBLIC andInfo:dict completionHandler:^(NSDictionary *resultDict) {
        [self parserData:resultDict];
    } errorHandler:^(NSError *error) {
        [self errorMessage:error];
    }];
}

- (void)parserData:(NSDictionary*)dict
{
    if ([[dict objectForKey:@"response_code"] intValue] == 0){
          _mtvContent.text = [NSString stringWithFormat:@"%@",dict];
    }
    else{
        NSString * message = [[ToolFunctions shareToolFunction]parserError:[[dict objectForKey:@"response_code"] intValue]];
        UIAlertView * alert = [[UIAlertView alloc]initWithTitle:@"Lỗi" message:message delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
        [alert show];
    }
    [self hidenToastActivity];
}

- (void)errorMessage:(NSError*)error
{
    [self hidenToastActivity];
    UIAlertView * alert = [[UIAlertView alloc]initWithTitle:@"Lỗi" message:[NSString stringWithFormat:@"%@",error.localizedDescription] delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
    [alert show];
}

#pragma mark - Toast View

- (void)showMessage:(NSString*)messgae
{
    [self.view makeToast:messgae duration:3.0 position:CSToastPositionCenter];
}

- (void)showToastActivity
{
    CSToastStyle *style = [[CSToastStyle alloc] initWithDefaultStyle];
    style.backgroundColor = [UIColor clearColor];
    [CSToastManager setSharedStyle:style];
    
    [self.view makeToastActivity:CSToastPositionCenter];
}

- (void)hidenToastActivity
{
    [self.view hideToastActivity];
}

@end
